package disks

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/disks"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func utilityDiskListTypesCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*disks.ListTypes, error) {
	c := m.(*controller.ControllerCfg)
	req := disks.ListTypesRequest{
		Detailed: false,
	}

	log.Debugf("utilityDiskListTypesCheckPresence: load disk list Types Detailed")
	typesList, err := c.CloudBroker().Disks().ListTypes(ctx, req)
	if err != nil {
		return nil, err
	}

	return typesList, nil
}
