package disks

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/disks"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func utilityDiskListTypesDetailedCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*disks.ListTypes, error) {
	c := m.(*controller.ControllerCfg)

	log.Debugf("utilityDiskListTypesDetailedCheckPresence: load disk list Types Detailed")
	listTypesDetailed, err := c.CloudBroker().Disks().ListTypes(ctx, disks.ListTypesRequest{
		Detailed: true,
	})

	log.Debugf("%+v", listTypesDetailed.Data[0].(map[string]interface{}))

	if err != nil {
		return nil, err
	}

	return listTypesDetailed, nil
}
