package rg

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"

	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/account"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/extnet"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/grid"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func existAccountID(ctx context.Context, d *schema.ResourceData, m interface{}) (bool, error) {
	c := m.(*controller.ControllerCfg)
	accountId := uint64(d.Get("account_id").(int))

	req := account.ListRequest{}

	accountList, err := c.CloudBroker().Account().List(ctx, req)
	if err != nil {
		return false, err
	}

	return len(accountList.FilterByID(accountId).Data) != 0, nil
}

func existGID(ctx context.Context, d *schema.ResourceData, m interface{}) (bool, error) {
	c := m.(*controller.ControllerCfg)

	gid := uint64(d.Get("gid").(int))

	gidList, err := c.CloudBroker().Grid().List(ctx, grid.ListRequest{})
	if err != nil {
		return false, err
	}

	for _, elem := range gidList.Data {
		if elem.GID == gid {
			return true, nil
		}
	}

	return false, nil
}

func existExtNet(ctx context.Context, d *schema.ResourceData, m interface{}) (bool, error) {
	c := m.(*controller.ControllerCfg)
	extNetId := uint64(d.Get("ext_net_id").(int))

	req := extnet.ListRequest{
		AccountID: uint64(d.Get("account_id").(int)),
	}

	listExtNet, err := c.CloudBroker().ExtNet().List(ctx, req)
	if err != nil {
		return false, err
	}

	return len(listExtNet.FilterByID(extNetId).Data) != 0, nil
}
